From 43964de8ef22128b4e97ed0ad985c65623da8ce2 Mon Sep 17 00:00:00 2001
From: guowenxue <guowenxue@gmail.com>
Date: Mon, 12 Aug 2019 15:24:48 +0800
Subject: [PATCH] Add util-linux/ build shell script

---
 3rdparty/util-linux/build.sh |  100 ++++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 100 insertions(+), 0 deletions(-)

diff --git a/3rdparty/util-linux/build.sh b/3rdparty/util-linux/build.sh
new file mode 100755
index 0000000..a526325
--- /dev/null
+++ b/3rdparty/util-linux/build.sh
@@ -0,0 +1,100 @@
+#!/bin/bash
+
+#+--------------------------------------------------------------------------------------------
+#|Description:  This shell script used download and compile util-linux for ARM
+#|     Author:  GuoWenxue <guowenxue@gmail.com>
+#|  ChangeLog:
+#|           1, Initialize 1.0.0 on 2011.04.12
+#+--------------------------------------------------------------------------------------------
+
+PREFIX_PATH=`pwd`/../install/
+
+LYFTP_SRC=ftp://master.iot-yun.club/src/
+
+CROSSTOOL=/opt/buildroot/cortex-a5/bin/arm-linux-
+
+function msg_banner()
+{
+    echo ""
+    echo "+-----------------------------------------------------------------------"
+    echo "|  $1 "
+    echo "+-----------------------------------------------------------------------"
+    echo ""
+}
+
+function check_result()
+{
+    if [ $? != 0 ] ; then
+       echo ""
+       echo "+-----------------------------------------------------------------------"
+       echo "|  $1 "
+       echo "+-----------------------------------------------------------------------"
+       echo ""
+       exit ;
+    fi
+}
+
+function export_cross()
+{
+    # export cross toolchain
+    export CC=${CROSSTOOL}gcc
+    export AS=${CROSSTOOL}as
+    export AR=${CROSSTOOL}ar
+    export LD=${CROSSTOOL}ld
+    export NM=${CROSSTOOL}nm
+    export RANLIB=${CROSSTOOL}ranlib
+    export OBJDUMP=${CROSSTOOL}objdump
+    export STRIP=${CROSSTOOL}strip
+
+    # export cross configure 
+    export CONFIG_CROSS=" --build=i686-pc-linux --host=arm-linux "
+
+    # Clear LDFLAGS and CFLAGS
+    export LDFLAGS=
+    export CFLAGS=
+}
+
+
+function compile_util-linux()
+{
+    SRC_NAME=util-linux-2.33
+    PACK_SUFIX=tar.xz
+
+    if [ -f ${PREFIX_PATH}/sbin/fsck ] ; then
+        msg_banner "$SRC_NAME already compile and installed"
+        return 0;
+    fi
+
+    msg_banner "Start donwload $SRC_NAME "
+    if [ ! -f ${SRC_NAME}.${PACK_SUFIX} ] ; then
+        # https://github.com/karelzak/util-linux/releases
+        wget ${LYFTP_SRC}/${SRC_NAME}.${PACK_SUFIX}
+        check_result "ERROR: download ${SRC_NAME} failure"
+    fi
+
+    tar -xJf ${SRC_NAME}.${PACK_SUFIX}
+    cd ${SRC_NAME}
+
+    msg_banner "Start cross compile $SRC_NAME "
+
+    ./configure --prefix=${PREFIX_PATH} ${CONFIG_CROSS} --enable-static \
+        --without-ncursesw --without-selinux --without-audit --without-udev \
+        --without-ncurses --without-tinfo --without-utempter --without-cap-ng \
+         --without-user --without-btrfs --without-systemd --without-python
+
+    check_result "ERROR: configure ${SRC_NAME} failure"
+
+    make && make install
+#    check_result "ERROR: compile ${SRC_NAME} failure"
+
+
+    ${STRIP} ${PREFIX_PATH}/sbin/fsck
+
+    cd -
+}
+
+export_cross
+
+compile_util-linux
+
+

--
Gitblit v1.9.1